#ifndef ANIM_BOUCLE_H_INCLUDED
#define ANIM_BOUCLE_H_INCLUDED

#include "Animation.h"

///Développeur: Jovian Hersemeule
///Dernière mise à jour le: 21/08/2013
///Objet: debug primaire, chgmt calcul

/*
==L'objet Anim_Boucle==
    +Argument
        VOID
    +Descriptif:
        Permet de créer une animation durable qui boucle: le fumée d'une usine,
        un bonhomme qui court, une roue qui tourne, etc...
        Une animation de ce genre hérite de cette classe.
[Fonctions]
FONCTIONS HERITEES: play; stop; pause

-coller:
    +Arguments:
        -Pointeur sur une SDL_Surface.
    +Renvoi:
        VOID
    +Descriptif:
        Permet de coller sur une surface l'image active, si l'anim est en cours.
*/

class Anim_Boucle : public Animation
{
    public:
    Anim_Boucle(Uint32 tempsFrequence);
    virtual ~Anim_Boucle();
    virtual void coller(SDL_Surface* support, int x, int y, bool centrer=0);

    protected:
    /*Aucun attribut supplémentaire requis.*/
};

#endif // ANIM_BOUCLE_H_INCLUDED
