#ifndef PLUIEFLAMME_H_INCLUDED
#define PLUIEFLAMME_H_INCLUDED

/**
    Modifié le: 28_08_2013
    Objet: Vecteurs + floats et resistance
    Problème(s) constaté(s):    - La résistance donne un bel effet, mais très bref.
                                - La résistance est constante.
    A faire: Faire évoluer la transparence.
**/

#include <iostream>
#include <SDL/SDL.h>

#include <ctime>
#include <cstdlib>

#include <vector>

#include "Vecteur.h"
#include "Coordonnee.h"
#include "FeuFolet.h"

/*
 + Permet de créer une explosion de couleurs.
 ! Initiliser la SDL et le srand
*/

class PluieFlamme
{
    public:
    PluieFlamme(DoubleAxe origine,int nbPop,int power,//Parramètres de construction
                float graviteY,int rayon,//Attributs physiques
                Uint32 couleur, float resistance);//Couleurs
    void deplacement();
    void dessiner(SDL_Surface* support);
    bool estFini(SDL_Surface* support);//Support pour savoir les dimensions

    protected:
    Vecteur m_graviteY;
    int m_rayon;
    Uint32 m_couleur;
    float m_resist;

    std::vector<Vecteur> m_force;
    std::vector<Vecteur> m_position;
};

#endif // PLUIEFLAMME_H_INCLUDED
